import { DomGeometryBox, DomGeometryWidthHeight } from "dojo/dom-geometry";

import { _WidgetBaseConstructor } from "dijit/_WidgetBase";

interface _ContentPaneResizeMixin {

    /**
     * - false - don't adjust size of children
     * - true - if there is a single visible child widget, set it's size to however big the ContentPane is
     */
    doLayout: boolean;

    /**
     * Indicates that this widget will call resize() on it's child widgets
     * when they become visible.
     */
    isLayoutContainer: boolean;

    /**
     * See `dijit/layout/_LayoutWidget.startup()` for description.
     * Although ContentPane doesn't extend _LayoutWidget, it does implement
     * the same API.
     */
    startup(): void;

    /**
     * See `dijit/layout/_LayoutWidget.resize()` for description.
     * Although ContentPane doesn't extend _LayoutWidget, it does implement
     * the same API.
     */
    resize(changeSize?: DomGeometryBox, resultSize?: DomGeometryWidthHeight): void;
}

type _ContentPaneResizeMixinConstructor = _WidgetBaseConstructor<_ContentPaneResizeMixin>;

declare const _ContentPaneResizeMixin: _ContentPaneResizeMixinConstructor;
export = _ContentPaneResizeMixin;
